#ifndef MAKEBESTMOVE_H_INCLUDED
#define MAKEBESTMOVE_H_INCLUDED
//1=red soldier 2=red king 3=black soldier 4=black king.
//I had to create a separate function because the earlier function checked it for the whole board.
//The purpose of doing so was that since multiple jumps are possible, the function can be recalled again to check for jumps.
void LegalMove
{
	//This function is supposed to collect all possible moves on the board.
	//This part of the function can be used to find if the move made is legal or not.
	if(turn%2==0)
	{

		//for red soldier
		if(piece==1)//red soldier
		{
			//To find moves, we use Movepos function
			if(grid[x+1][y-1]==0)
				Movepos(1,3,1)
			if(grid[x+1][y+1]==0)
				Movepos(1,4,1)
		}


		if(piece==2)//red king
		{
			if(grid[x+1][y-1]==0)
				Movepos(2,3,1)
			if(grid[x+1][y+1]==0)
				Movepos(2,4,1)
			if(grid[x-1][y+1]==0)
				Movepos(2,1,1)
			if(grid[x-1][y-1]==0)
				Movepos(2,2,1)
			//jumps
			if((grid[x+1][y-1]==4||grid[x+1][y-1]==3)&&grid[x+2][y-2]==0)
				Movepos(2,3,2)
			if((grid[x+1][y+1]==4||grid[x+1][y+1]==3)&&grid[x+2][y+2]==0)
				Movepos(2,4,2)
			if((grid[x-1][y+1]==4||grid[x-1][y+1]==3)&&grid[x-2][y+2]==0)
				Movepos(2,1,2)
			if((grid[x-1][y-1]==4||grid[x-1][y-1]==3)&&grid[x-2][y-2]==0)
				Movepos(2,2,2)
		}
	}
	//This part of the function can be used to find which are the possible moves we can play.
	if(turn%2==1)
	{


		if(piece==3)//black soldier
		{
			if(grid[x-1][y+1]==0)
				Movepos(3,1,1)
			if(grid[x-1][y-1]==0)
				Movepos(3,2,1)
		}
		if(piece==4)
		{
			if(grid[x+1][y-1]==0)
				Movepos(4,3,1)
			if(grid[x+1][y+1]==0)
				Movepos(4,4,1)
			if(grid[x-1][y+1]==0)
				Movepos(4,1,1)
			if(grid[x-1][y-1]==0)
				Movepos(4,2,1)

			if((grid[x+1][y-1]==1||grid[x+1][y-1]==2)&&grid[x+2][y-2]==0)
				Movepos(4,3,2)
			if((grid[x+1][y+1]==1||grid[x+1][y+1]==2)&&grid[x+2][y+2]==0)
				Movepos(4,4,2)
			if((grid[x-1][y+1]==1||grid[x-1][y+1]==2)&&grid[x-2][y+2]==0)
				Movepos(4,1,2)
			if((grid[x-1][y-1]==1||grid[x-1][y-1]==2)&&grid[x-2][y-2]==0)
				Movepos(4,2,2)
		}
	}
}
//I get value of k  from LegalMoves function after running it over the array.
void
{
	//This function is supposed to give a best move out of the possible moves.
	//since using the above function, I have an array containing the possible moves of black.

	for(i=0;i<=j;i++)
	{
		//To find best such poss.Poss[i][x][y]
		X=L[i]/10;
		Y=L[i]%10;
		A=N[i]/100;
		C=N[i]%10;
		B=(N[i]%100)/10;
		//for Pgrid[i] x 1to8 y 1to8.
		for(x=1;x<9;x++)
		{
			for(y=1;y<9;y++)
			{
				Pgrid[x][y]=grid[x][y];
			}
		}

		pieces=0;defense=0;attack=0;
		for(x=1;x<9;x++)
		{
			for(y=1;y<9;y++)
			{
				piece=Pgrid[x][y]
				if(piece==3||piece==4)
				{

					if(Pgrid[x+1][y-1]==3||Pgrid[x+1][y-1]==4||Pgrid[x+1][y+1]==3||Pgrid[x+1][y+1]==4)
					defense++;
					if(piece==3)
					{
						if((Pgrid[x-1][y-1]==1&&Pgrid[x-2][y-2]==0)||(Pgrid[x-1][y-1]==2&&Pgrid[x-2][y-2]==0)||(Pgrid[x-1][y+1]==1&&Pgrid[x-2][y+2]==0)||(Pgrid[x-1][y+1]==2&&Pgrid[x-2][y+2]==0)
						attack++;
						if((Pgrid[x-1][y-1]==2&&Pgrid[x-2][y-2]==0)||(Pgrid[x-1][y+1]==2&&Pgrid[x-2][y+2]==0)
						attack=attack+2;
						if((Pgrid[x-1][y-1]==1&&Pgrid[x+1][y+1]==0)||(Pgrid[x-1][y-1]==2&&Pgrid[x+1][y+1]==0)||(Pgrid[x-1][y+1]==1&&Pgrid[x+1][y-1]==0)||(Pgrid[x+1][y+1]==2&&Pgrid[x-1][y-1]==0)||(Pgrid[x-1][y+1]==2&&Pgrid[x+1][y-1]==0)||(Pgrid[x+1][y-1]==2&&Pgrid[x-1][y+1]==0))
						threat++;

					}
					if(piece==4)
					{
						if((Pgrid[x-1][y-1]==1&&Pgrid[x-2][y-2]==0)||(Pgrid[x-1][y-1]==2&&Pgrid[x-2][y-2]==0)||(Pgrid[x-1][y+1]==1&&Pgrid[x-2][y+2]==0)||(Pgrid[x-1][y+1]==2&&Pgrid[x-2][y+2]==0)
						attack++;
						if((Pgrid[x-1][y-1]==2&&Pgrid[x-2][y-2]==0)||(Pgrid[x-1][y+1]==2&&Pgrid[x-2][y+2]==0)
						attack=attack+2;
						if((Pgrid[x-1][y-1]==1&&Pgrid[x+1][y+1]==0)||(Pgrid[x-1][y-1]==2&&Pgrid[x+1][y+1]==0)||(Pgrid[x-1][y+1]==1&&Pgrid[x+1][y-1]==0)||(Pgrid[x+1][y+1]==2&&Pgrid[x-1][y-1]==0)||(Pgrid[x-1][y+1]==2&&Pgrid[x+1][y-1]==0)||(Pgrid[x+1][y-1]==2&&Pgrid[x-1][y+1]==0))
						threat+=3;
						if((Pgrid[x+1][y+1]==1&&Pgrid[x+2][y+2]==0)||(Pgrid[x+1][y+1]==2&&Pgrid[x+2][y+2]==0)||(Pgrid[x+1][y-1]==1&&Pgrid[x+2][y-2]==0)||(Pgrid[x+1][y-1]==2&&Pgrid[i][x+2][y-2]==0)
						attack++;
						if((Pgrid[x+1][y+1]==2&&Pgrid[x+2][y+2]==0)||(Pgrid[x+1][y-1]==2&&Pgrid[x+2][y-2]==0)
						attack=attack+2;

					}
				}
			}
		}
		f=f*(defense*threat)/attack;g=g*(attack*threat)/defense;h=h*(attack*defense)/threat;
		Para=f*attack+g*defense+h*threat;

		for(x=1;x<9;x++)
		{
			for(y=1;y<9;y++)
			{
				Pgrid[i][x][y]=grid[x][y];
			}
		}
		PMove(X,Y,A,B,C);
		for(x=1;x<9;x++)
		{
			for(y=1;y<9;y++)
			{
				piece=Pgrid[i][x][y];
				if(piece==3||piece==4)
				{
					pieces++;
					if(Pgrid[i][x+1][y-1]==3||Pgrid[i][x+1][y-1]==4||Pgrid[i][x+1][y+1]==3||Pgrid[i][x+1][y+1]==4)
					defense++;
					if(piece==3)
					{
						if((Pgrid[i][x-1][y-1]==1&&Pgrid[i][x-2][y-2]==0)||(Pgrid[i][x-1][y-1]==2&&Pgrid[i][x-2][y-2]==0)||(Pgrid[i][x-1][y+1]==1&&Pgrid[i][x-2][y+2]==0)||(Pgrid[i][x-1][y+1]==2&&Pgrid[i][x-2][y+2]==0)
						attack++;
						if((Pgrid[i][x-1][y-1]==2&&Pgrid[i][x-2][y-2]==0)||(Pgrid[i][x-1][y+1]==2&&Pgrid[i][x-2][y+2]==0)
						attack=attack+2;
						if((Pgrid[i][x-1][y-1]==1&&Pgrid[i][x+1][y+1]==0)||(Pgrid[i][x-1][y-1]==2&&Pgrid[i][x+1][y+1]==0)||(Pgrid[i][x-1][y+1]==1&&Pgrid[i][x+1][y-1]==0)||(Pgrid[i][x+1][y+1]==2&&Pgrid[i][x-1][y-1]==0)||(Pgrid[i][x-1][y+1]==2&&Pgrid[i][x+1][y-1]==0)||(Pgrid[i][x+1][y-1]==2&&Pgrid[i][x-1][y+1]==0))
						threat++;

					}
					if(piece==4)
					{
						if((Pgrid[i][x-1][y-1]==1&&Pgrid[i][x-2][y-2]==0)||(Pgrid[i][x-1][y-1]==2&&Pgrid[i][x-2][y-2]==0)||(Pgrid[i][x-1][y+1]==1&&Pgrid[i][x-2][y+2]==0)||(Pgrid[i][x-1][y+1]==2&&Pgrid[i][x-2][y+2]==0)
						attack++;
						if((Pgrid[i][x-1][y-1]==2&&Pgrid[i][x-2][y-2]==0)||(Pgrid[i][x-1][y+1]==2&&Pgrid[i][x-2][y+2]==0)
						attack=attack+2;
						if((Pgrid[i][x-1][y-1]==1&&Pgrid[i][x+1][y+1]==0)||(Pgrid[i][x-1][y-1]==2&&Pgrid[i][x+1][y+1]==0)||(Pgrid[i][x-1][y+1]==1&&Pgrid[i][x+1][y-1]==0)||(Pgrid[i][x+1][y+1]==2&&Pgrid[i][x-1][y-1]==0)||(Pgrid[i][x-1][y+1]==2&&Pgrid[i][x+1][y-1]==0)||(Pgrid[i][x+1][y-1]==2&&Pgrid[i][x-1][y+1]==0))
						threat+=3;
						if((Pgrid[i][x+1][y+1]==1&&Pgrid[i][x+2][y+2]==0)||(Pgrid[i][x+1][y+1]==2&&Pgrid[i][x+2][y+2]==0)||(Pgrid[i][x+1][y-1]==1&&Pgrid[i][x+2][y-2]==0)||(Pgrid[i][x+1][y-1]==2&&Pgrid[i][x+2][y-2]==0)
						attack++;
						if((Pgrid[i][x+1][y+1]==2&&Pgrid[i][x+2][y+2]==0)||(Pgrid[i][x+1][y-1]==2&&Pgrid[i][x+2][y-2]==0)
						attack=attack+2;

					}



				}
			}
		}

	Para[i]=f*attack+g*defense+h*threat;
	}
	for(i=0;i<=j;i++)
	{
		if(Para[i]>=max)
		{max=Para[i];t=i;}
	}
}
// so t is the index of the best move.
#endif // MAKEBESTMOVE_H_INCLUDED
